remote.c File Reference
Include dependency graph for remote.c:

## Functions

SPA_EXPORT const char * | pw_remote_state_as_string (enum pw_remote_state state)
SPA_EXPORT struct pw_remote * | pw_remote_new (struct pw_core *core, struct pw_properties *properties, size_t user_data_size)
SPA_EXPORT void | pw_remote_destroy (struct pw_remote *remote)
SPA_EXPORT struct pw_core * | pw_remote_get_core (struct pw_remote *remote)
| Get the core used to construct this remote. More...
SPA_EXPORT const struct pw_properties * | pw_remote_get_properties (struct pw_remote *remote)
| Get the remote properties. More...
SPA_EXPORT void * | pw_remote_get_user_data (struct pw_remote *remote)
| Get the user_data. More...
SPA_EXPORT enum pw_remote_state | pw_remote_get_state (struct pw_remote *remote, const char **error)
| Get the current state, error is set when state is PW_REMOTE_STATE_ERROR. More...
SPA_EXPORT void | pw_remote_add_listener (struct pw_remote *remote, struct spa_hook *listener, const struct pw_remote_events *events, void *data)
| Add listener for events. More...
SPA_EXPORT struct pw_core_proxy * | pw_remote_get_core_proxy (struct pw_remote *remote)
| Get the core proxy, can only be called when connected. More...
SPA_EXPORT const struct pw_core_info * | pw_remote_get_core_info (struct pw_remote *remote)
| Get the remote core info, can only be called when connected. More...
SPA_EXPORT struct pw_proxy * | pw_remote_find_proxy (struct pw_remote *remote, uint32_t id)
| Get the proxy with the given id. More...
SPA_EXPORT int | pw_remote_connect (struct pw_remote *remote)
SPA_EXPORT int | pw_remote_connect_fd (struct pw_remote *remote, int fd)
SPA_EXPORT int | pw_remote_steal_fd (struct pw_remote *remote)
| Steal the fd of the remote connection or < 0 on error. More...
SPA_EXPORT int | pw_remote_disconnect (struct pw_remote *remote)
SPA_EXPORT struct pw_proxy * | pw_remote_export (struct pw_remote *remote, struct pw_node *node)
| run a local node in a remote graph More...

## Function Documentation

## pw_remote_add_listener()

SPA_EXPORT void pw_remote_add_listener | ( | struct pw_remote * | remote,
|  | struct spa_hook * | listener,
|  | const struct pw_remote_events * | events,
|  | void * | data
| ) |  |

Add listener for events.

## pw_remote_connect()

SPA_EXPORT int pw_remote_connect | ( | struct pw_remote * | remote | ) |

## pw_remote_connect_fd()

SPA_EXPORT int pw_remote_connect_fd | ( | struct pw_remote * | remote,
|  | int | fd
| ) |  |

## pw_remote_destroy()

SPA_EXPORT void pw_remote_destroy | ( | struct pw_remote * | remote | ) |

References pw_properties_free(), pw_protocol_client_destroy, pw_remote_disconnect(), PW_REMOTE_STATE_UNCONNECTED, and pw_stream_destroy().

Referenced by pw_core::pw_core_destroy().

## pw_remote_disconnect()

SPA_EXPORT int pw_remote_disconnect | ( | struct pw_remote * | remote | ) |

References pw_core_info_free(), pw_protocol_client_disconnect, pw_proxy_destroy(), and pw_stream_disconnect().

Referenced by pw_remote_destroy(), and pw_remote_steal_fd().

## pw_remote_export()

SPA_EXPORT struct pw_proxy* pw_remote_export | ( | struct pw_remote * | remote,
|  | struct pw_node * | node
| ) |  |

run a local node in a remote graph

## pw_remote_find_proxy()

SPA_EXPORT struct pw_proxy* pw_remote_find_proxy | ( | struct pw_remote * | remote,
|  | uint32_t | id
| ) |  |

Get the proxy with the given id.

## pw_remote_get_core()

SPA_EXPORT struct pw_core* pw_remote_get_core | ( | struct pw_remote * | remote | ) |

Get the core used to construct this remote.

## pw_remote_get_core_info()

SPA_EXPORT const struct pw_core_info* pw_remote_get_core_info | ( | struct pw_remote * | remote | ) |

Get the remote core info, can only be called when connected.

## pw_remote_get_core_proxy()

SPA_EXPORT struct pw_core_proxy* pw_remote_get_core_proxy | ( | struct pw_remote * | remote | ) |

Get the core proxy, can only be called when connected.

## pw_remote_get_properties()

SPA_EXPORT const struct pw_properties* pw_remote_get_properties | ( | struct pw_remote * | remote | ) |

Get the remote properties.

## pw_remote_get_state()

SPA_EXPORT enum pw_remote_state pw_remote_get_state | ( | struct pw_remote * | remote,
|  | const char ** | error
| ) |  |

Get the current state, error is set when state is PW_REMOTE_STATE_ERROR.

## pw_remote_get_user_data()

SPA_EXPORT void* pw_remote_get_user_data | ( | struct pw_remote * | remote | ) |

Get the user_data.

The size was given in pw_remote_new

## pw_remote_new()

SPA_EXPORT struct pw_remote* pw_remote_new | ( | struct pw_core * | core,
|  | struct pw_properties * | properties,
|  | size_t | user_data_size
| ) |  |

References pw_core_find_protocol(), pw_fill_remote_properties(), pw_module_load(), pw_properties_free(), pw_properties_get(), pw_properties_new(), pw_protocol_new_client, PW_REMOTE_PROP_PROTOCOL, and PW_REMOTE_STATE_UNCONNECTED.

## pw_remote_state_as_string()

SPA_EXPORT const char* pw_remote_state_as_string | ( | enum pw_remote_state | state | ) |

References PW_REMOTE_STATE_CONNECTED, PW_REMOTE_STATE_CONNECTING, PW_REMOTE_STATE_ERROR, and PW_REMOTE_STATE_UNCONNECTED.

## pw_remote_steal_fd()

SPA_EXPORT int pw_remote_steal_fd | ( | struct pw_remote * | remote | ) |

Steal the fd of the remote connection or < 0 on error.

The remote will be in the unconnected state after this call.

References pw_protocol_client_steal_fd, and pw_remote_disconnect().